//
//  TicTacToeGame.m
//  TicTacToeSolution
//
//  Created by David Fisher on 9/4/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "RHTicTacToeGame.h"

@interface RHTicTacToeGame()
- (void) _checkForWinner;
- (BOOL) _didMarkWin:(RHTicTacToeMark) markType;
- (BOOL) _isBoardFull;
@end


@implementation RHTicTacToeGame
@synthesize gameState;

- (RHTicTacToeMark) getMarkInRow:(int) aRow column:(int) aColumn
{
	if (aRow >= kRHNumRows || aColumn >= kRHNumColumns || aRow < 0 || aColumn < 0) {
		return 0;
	}
	return gameBoard[aRow][aColumn];
}
- (void) playerPressedRow:(int) aRow column:(int) aColumn
{
	NSLog(@"Player pressed row=%d  column=%d",aRow,aColumn);
	if (aRow >= kRHNumRows || aColumn >= kRHNumColumns || aRow < 0 || aColumn < 0) { // Check the row and column is on the board
		return;  
	}
	if (gameBoard[aRow][aColumn] != RHTicTacToeMarkNone) { // Check if the spot is free
		return;
	}
	if (self.gameState == RHTicTacToeGameStateXTurn) {
		gameBoard[aRow][aColumn] = RHTicTacToeMarkX;
		gameState = RHTicTacToeGameStateOTurn;
	}
	else if (self.gameState == RHTicTacToeGameStateOTurn) {
		gameBoard[aRow][aColumn] = RHTicTacToeMarkO;
		gameState = RHTicTacToeGameStateXTurn;
	}
	[self _checkForWinner];
}
- (void) resetBoard
{
	int row,col;
	for (row=0; row<kRHNumRows; row++) {
		for (col=0; col<kRHNumColumns; col++) {
			gameBoard[row][col] = RHTicTacToeMarkNone;
		}
	}
	self.gameState = RHTicTacToeGameStateXTurn;
}

#pragma mark -
#pragma mark Internal methods
- (void) _checkForWinner
{
	if ([self _didMarkWin:RHTicTacToeMarkX]) {
		NSLog(@"X won the game");
		gameState = RHTicTacToeGameStateXWon;
	}
	else if ([self _didMarkWin:RHTicTacToeMarkO]) {
		NSLog(@"O won the game");
		gameState = RHTicTacToeGameStateOWon;
	}
	else if ([self _isBoardFull]) {
		NSLog(@"Cat");
		gameState = RHTicTacToeGameStateTie;
	}
}
- (BOOL) _didMarkWin:(RHTicTacToeMark) markType
{
	BOOL marksMatchType;
	int i,j;
	//NSLog(@"Check for %@ win",markType == MARK_X ? @"X" : @"O");
	
	// Check all the rows
	for ( i = 0; i<kRHNumRows; i++) {
		marksMatchType = YES;
		for ( j = 0; j<kRHNumColumns; j++) {
			NSLog(@"Row check for i=%d j=%d",i,j);
			if (markType != gameBoard[i][j]) {
				marksMatchType = NO;
			}
		}
		if (marksMatchType) {
			NSLog(@"Row win for %@", markType == RHTicTacToeMarkX ? @"X" : @"O");
			return YES;
		}
	}
	
	// Check all the columnss
	for ( j = 0; j<kRHNumColumns; j++) {
		marksMatchType = YES;
		for ( i = 0; i<kRHNumRows; i++) {
			if (markType != gameBoard[i][j]) {
				marksMatchType = NO;
			}
		}
		if (marksMatchType) {
			NSLog(@"Column win for %@", markType == RHTicTacToeMarkX ? @"X" : @"O");
			return YES;
		}
	}
	
	// Check the down diagonal
	marksMatchType = YES;
	for ( i=0; i<kRHNumRows; i++) {
		if (markType != gameBoard[i][i]) {
			marksMatchType = NO;
		}
	}
	if (marksMatchType) {
		NSLog(@"Down diag win for %@", markType == RHTicTacToeMarkX ? @"X" : @"O");
		return YES;
	}
	// Check the up diagonal
	marksMatchType = YES;
	for ( i=0; i<kRHNumRows; i++) {
		if (markType != gameBoard[kRHNumRows-i-1][i]) {
			marksMatchType = NO;
		}
	}
	if (marksMatchType) {
		NSLog(@"Up diag win for %@", markType == RHTicTacToeMarkX ? @"X" : @"O");
		return YES;
	}
	
	return NO; // No winner.  Checked all possible wins.
}
- (BOOL) _isBoardFull
{
	int i,j;
	NSLog(@"is board full");
	for ( i = 0; i<kRHNumRows; i++) {
		for ( j = 0; j<kRHNumColumns; j++) {
			if (gameBoard[i][j] == RHTicTacToeMarkNone) {
				NSLog(@"Found a blank at %d %d", i,j);
				return NO;
			}
		}
	}
	NSLog(@"Tie game");
	return YES; // No blanks found.  The board is full.
}

@end
